SystemOrganization addCategory: #'Xenon-Tests'!

Object subclass: #XeEmptyMainWhenItHasManyReturnTypeScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeEmptyMainWhenItHasManyReturnTypeScenario methodsFor: 'c code' stamp: 'BernardoContreras 2/27/2012 18:55'!
main
	<returnType: #XeIntType>
	<returnType: #XeVoidType>
! !

Object subclass: #XeEmptyMainWhenReturnTypeIsDefaultScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeEmptyMainWhenReturnTypeIsDefaultScenario methodsFor: 'c code' stamp: 'BernardoContreras 2/26/2012 16:09'!
main
! !

Object subclass: #XeEmptyMainWhenReturnTypeIsIntegerScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeEmptyMainWhenReturnTypeIsIntegerScenario methodsFor: 'c code' stamp: 'BernardoContreras 2/27/2012 18:54'!
main
	<returnType: #XeIntType>
! !

TestCase subclass: #XeTranslateMainTest
	instanceVariableNames: 'translator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeTranslateMainTest methodsFor: 'running' stamp: 'BernardoContreras 2/26/2012 16:42'!
setUp
	translator := XeTranslator new! !

!XeTranslateMainTest methodsFor: 'tests' stamp: 'BernardoContreras 2/27/2012 02:11'!
testTranslateEmptyMainWhenItHasManyReturnTypes
	self should: [translator translate: XeEmptyMainWhenItHasManyReturnTypeScenario] raise: XeTooManyReturnTypesError
! !

!XeTranslateMainTest methodsFor: 'tests' stamp: 'BernardoContreras 2/27/2012 00:52'!
testTranslateEmptyMainWhenReturnTypeIsDefault
	| actual expected |
	actual := translator translate: XeEmptyMainWhenReturnTypeIsDefaultScenario.
	expected := 'void main(){
}'.
	self assert: actual equals: expected! !

!XeTranslateMainTest methodsFor: 'tests' stamp: 'BernardoContreras 2/27/2012 00:53'!
testTranslateEmptyMainWhenReturnTypeIsInteger
	| actual expected |
	actual := translator translate: XeEmptyMainWhenReturnTypeIsIntegerScenario.
	expected := 'int main(){
}'.
	self assert: actual equals: expected! !
